<?php

###########################################################################################################
#	Manipulação de arquivos em geral
#	By: Leonardo Breda	www.leobreda.net
#	2009-04-05	v1.0	Criação
###########################################################################################################



Class File
{
	private $i, $saida;

	###########################################################################################################
	# Retorna os arquivos de determinado diretório
	# File::GetFiles("c:/arquivos/");
	#
	###########################################################################################################
	public static function GetFiles($dir)
	{
		GLOBAL $cfg;

		$pasta = opendir($dir);
		$i=0;
		while (false !==($file = readdir($pasta)))
		{
			if (($file != '.') && ($file != '..'))
			{
				if(!is_dir($dir.$file))
				{	
					$saida[$i][0] = $file;																	//Nome da pasta/arquivo			
					$saida[$i][1] = Mascara::ArquivoTamanho(filesize($dir.$file));					//	Tamanho do arquivo
					$saida[$i][2] = date ("d/m/Y H:i:s.", filemtime($dir.$file));						//	Data de modificação
					$saida[$i][3] = array_reverse(explode(".",$file));$saida[$i][4] = $saida[$i][4][0];		//	Extensão
					if(file_exists($cfg['path_fisico'].'theme/'.$cfg['theme'].'/icons/48x48/_'.$saida[$i][3].'.gif')==true)	// Ícone
					{$saida[$i][4] = '_'.$saida[$i][3];}else{$saida[$i][4] = '_';}
					$i++;
				}
			}
		}
		return $saida;	
	}


	###########################################################################################################
	#	Renomear arquivo
	#
	#	File::Rename("C:/web/images/img.jpg", "C:/web/images/123.jpg");
	#
	###########################################################################################################	
	public static function Rename($diretorio, $titulo)
	{
		$titulo = Mascara::RenameFile(strtolower($titulo), 40);
		if(file_exists($diretorio))
		{
			rename($diretorio, substr($diretorio,0,strrpos($diretorio,"/")+1).$titulo);		
		}
	}
		

	###########################################################################################################
	#	Autoriza o Download do arquivo
	###########################################################################################################	
	public static function Download($dir, $file, $group, $user)
	{
		$dir	= intval($dir);
		$file	= str_replace('/', '', $file);
		$group	= intval($group);
		$user	= intval($user);

		// Verifica se o usuário possui permissão de leitura a pasta
		$saida = Folder::GetInfo($dir, $group, $user);
		if(intval($saida[0][3])==1)
			return true;
		else
			return false;
	}
	
	###########################################################################################################
	#	Mover arquivo
	#
	#	File::Move("C:/web/images/img.jpg", "C:/web/videos/");
	#
	###########################################################################################################	
		public static function move($origem, $destino)
		{
			global $cfg;
			
			if(file_exists($cfg['path_files'].substr($origem,1)))
			{
				rename($cfg['path_files'].substr($origem,1), $cfg['path_files'].substr($destino,1).substr($origem,strripos($origem, "/")+1));
			}
		}
		

}



	Class Arquivo
	{
		var $diretorio, $id;
		var $titulo;
		var $tamanho;
		var $arquivo;
		var $erro;
		private $saida, $i;
		
	###########################################################################################################
	#	Efetua o upload do arquivo
	#
	#		Entra:   	diretório		: Diretório de destino
	#		 			titulo			: Nome do arquivo
	#		 			tamanho			: Tamanho máximo do arquivo (em bytes)
	#		 			arquivo			: Arquivo binário + caminho do arquivo (lado cliente)
	#
	#		Retorna: 	arquivo			: O nome do arquivo tratado
	#			 		tamanho			: Tamanho do arquivo (em bytes)
	#	 		 		erro			: Mensagem de erro
	###########################################################################################################	
		function EfetuaUpload()
		{
			$diretorio 		= strtolower(trim($this->diretorio));	//Diretório de destino
			$titulo 		= $this->titulo.'';						//Título do arquivo (se for informado)
			$tamanho 		= $this->tamanho;						//Tamanho máximo do arquivo (em bytes)
			$arquivo		= $this->arquivo;						//Arquivo binário	
			
			$this->erro = '';	//Nenhum erro até agora

				//1. Verifica se ultrapassou o tamanho máximo de arquivo		Tolerância: 10%
				if(intval($arquivo['size'])>intval($tamanho*1.1))
				{
					$this->erro = 'Erro: o tamanho do arquivo ultrapassou '.Mascara::ArquivoTamanho($tamanho);
					unset($diretorio, $titulo, $tamanho, $arquivo);
					return;
				}
			
				//2. Se o novo nome para o arquivo não for informado, mantém mesmo nome do arquivo.
				if($titulo=='')	{	$titulo = $arquivo['name'];}
					
				//3. Trata o nome do arquivo, com limite de 40 caracteres
				$titulo = Mascara::RenameFile($titulo, 40);
				
				//4. Efetua o Upload
				//* Verifique se o diretório temporário aceita mover arquivos. Consulte php.ini
				if(!move_uploaded_file($arquivo['tmp_name'], $diretorio.$titulo))
				{
					$this->erro = 'Não foi possível efetuar o upload. Favor contate o Administrador.\n\nCódigo de erro:'.$arquivo['error'].'\nDescrição do erro:'.print_r($arquivo).'\nDebug: ';	
					unset($diretorio, $titulo, $tamanho, $arquivo);
					return;
				}
			
				//7. Devolve o novo nome do arquivo, tamanho, e mensagem de erro em branco
				$this->titulo = $titulo;
				$this->tamanho = intval($arquivo['size']);
				$this->erro = '';
				
			unset($diretorio, $titulo, $tamanho, $arquivo);	
		}

	

		
		###########################################################################################################
		#	Retorna o TAMANHO do diretório, em bytes
		#
		#	Arquivo::getFolderSize("C:/web/images");
		###########################################################################################################	
		public static function getFolderSize($diretorio)
		{
			if(!file_exists($diretorio)) return 0;
			 if(is_file($diretorio)) return filesize($diretorio);
			$saida = 0;
		   foreach(glob($diretorio."/*") as $fn)
				$saida += Arquivo::getFolderSize($fn);
		   return $saida;
		}
 


		
	
		###########################################################################################################
		#	Cria diretório
		#
		#	Arquivo::CriaDiretorio("C:/web/images");
		#
		###########################################################################################################	
		public static function CriaDiretorio($diretorio)
		{
			GLOBAL $cfg;

			if(PHP_OS == "Linux")
			{
				$diretorio = str_replace("\\", "/", $diretorio); 
				$diretorioX = explode("/", $diretorio);
				$diretorioY = $diretorioX[0];
				for($i=1;$i<count($diretorioX);$i++)
				{
					$diretorioY.="/". $diretorioX[$i];
					if(!is_dir($diretorioY))
					{
						mkdir($diretorioY, 0757);
						$strSQL="INSERT INTO TB_FOLDER (NAME, PATH) VALUES ('".substr($diretorioY,strrpos($diretorioY,"/")+1)."','".str_replace($cfg["path_files"], "", $diretorioY)."/');";
						ExecutaSql($strSQL);
					}
				}
			}
			else
			{
				$diretorio = str_replace("/", "\\", $diretorio); 
				$diretorioX = explode("\\", $diretorio);
				$diretorioY = $diretorioX[0];
				for($i=1;$i<count($diretorioX);$i++)
				{
					$diretorioY.="\\". $diretorioX[$i];
					if(!is_dir($diretorioY))
					{
						mkdir($diretorioY, 0777);
						$strSQL="INSERT INTO TB_FOLDER (NAME, PATH) VALUES ('".substr($diretorioY,strrpos($diretorioY,"/")+1)."','".str_replace($cfg["path_files"], "", $diretorioY)."/');";
						ExecutaSql($strSQL);
					}
				}
			}
		}
			
		
	
		
		
		
	
		
		
		###########################################################################################################
		#	Exclui arquivo
		#
		#	Arquivo::ExcluiArquivo("C:/web/images/img.jpg");
		#
		###########################################################################################################	
		public static function ExcluiArquivo($caminho)
		{
			if(file_exists($caminho))
			{
				unlink($caminho);
			}
		}
		
		
	
		
		
		###########################################################################################################
		#	Exclui diretório
		#
		#	Arquivo::ExcluiDiretorio("C:/web/images");
		#
		###########################################################################################################	
		public static function ExcluiDiretorio($dir)
		{
			global $cfg;
				
			$diretorio=substr($dir,1);	//Evita o erro na recursividade
			if(is_dir($cfg['path_files'].$diretorio)) // verifica se realmente é uma pasta
   			{
				if($handle = opendir($cfg['path_files'].$diretorio))	//Abre o diretório
				{
					while(false !== ($file = readdir($handle))) // Varre cada um dos arquivos da pasta
					{
						if(($file == ".") or ($file == ".."))
						{
							continue;
						}
						if(is_dir($cfg['path_files'].$diretorio.$file.'/')) // verifica se o arquivo atual é uma pasta
						{
							//caso seja uma pasta, faz a chamada para a funcao novamente
							Arquivo::ExcluiDiretorio('/'.$diretorio.$file.'/');
						} else
						{
							// caso seja um arquivo, exclui ele
							unlink($cfg['path_files'].$diretorio.'/'.$file);
						}
					}
					// fecha a pasta aberta
       				closedir($handle);
					rmdir($cfg['path_files'].$diretorio);	//exclui o diretório
					
				// Exclui a pasta no SQL
					
					// Descobre o ID
					$strSQL="SELECT ID, PATH_ID FROM TB_FOLDER WHERE PATH='/".str_replace($cfg['path_files'], '', $diretorio)."'";
					$info=sql($strSQL);
					
					
					// Exclui as possíveis permissões de usuários
						$strSQL="DELETE FROM TB_SHARE_USER WHERE FOLDER_ID=".$info[0][0]." OR FOLDER_ID IN (".$info[0][1].")";
						ExecutaSql($strSQL);
						
						// Exclui pastas anteriores, e a própria pasta no SQL
						$strSQL="DELETE FROM TB_FOLDER WHERE PATH_ID LIKE '%,".$info[0][0]."' OR  PATH_ID LIKE '%,".$info[0][0].",%' OR ID=".$info[0][0]." ORDER BY ID DESC";
						ExecutaSql($strSQL);
					unset($info);
				}
				
				
				
				
					
			}
		}
	###########################################################################################################
	#	Lê arquivo texto (templates)
	#	2009-10-21	v1.0
	#
	#	Arquivo
	#
	###########################################################################################################	
		public static function LerArquivoTexto($caminho)
		{
			//1. Abre o arquivo
			$file = fopen($caminho, 'r');
			$saida='';
			$saida=fread($file, filesize($caminho));
			fclose($file);
			return $saida;	
		}//function LerArquivoTexto()
	
	}



?>
