<?php

###########################################################################################################
#	Manipulação de arquivos de imagem em geral
#	By: Leonardo Breda	www.leobreda.net
#	2009-04-05	v1.0	Criação
###########################################################################################################
Class Folder
{
	var $id;
	private $vetor, $i, $info;

	###########################################################################################################
	# Retorna o id da pasta
	# Folder::GetId("/videos/aulas/");
	###########################################################################################################
	public static function GetId($folder)
	{
		$strSQL="SELECT ID FROM TB_FOLDER WHERE PATH='".$folder."'";
		$sql=Sql($strSQL);
		return $sql[0][0];
	}


	###########################################################################################################
	# Retorna nome, caminho da pasta e as devidas permissões
	# Folder::GetInfo($id, $group, $user);
	###########################################################################################################
	public static function GetInfo($id, $group, $user)
	{
		$id=intval($id);
		$group=intval($group);
		$user=intval($user);
		
		$strSQL="SELECT A.NAME, A.PATH, A.RULE_WRITE, A.RULE_READ, (SELECT RULE_WRITE FROM TB_SHARE_USER WHERE FOLDER_ID=A.ID AND USER_ID=".$user.") AS RULE_WRITE_USER, (SELECT RULE_READ FROM TB_SHARE_USER WHERE FOLDER_ID=A.ID AND USER_ID=".$user.") AS RULE_READ_USER, A.PATH_ID FROM TB_FOLDER A WHERE A.ID=".$id;
		$vetor=Sql($strSQL);
		
	/*	$vetor[0][0] = Nome da pasta
		$vetor[0][1] = Path físico
		$vetor[0][2] = Permite escrita
		$vetor[0][3] = Permite leitura*/
		if($group==1) //grupo Admin tem acesso total...
		{
			$vetor[0][2]=1;
			$vetor[0][3]=1;
			unset($vetor[0][4],$vetor[0][5]);
		}
		else
		{
			if(($vetor[0][2]=='0')||($vetor[0][4]=='0'))
			{
				$vetor[0][2]=0;
			}	
			else
			{	
				$vetor[0][2]=1;
			}
				
			if(($vetor[0][3]=='0')||($vetor[0][5]=='0'))
			{
				$vetor[0][3]=0;
			}	
			else
			{	
				$vetor[0][3]=1;
			}


			unset($vetor[0][4],$vetor[0][5]);
			
			// Verifica se a pasta possui restrições em GRAVAÇÃO na(s) pasta(s) anteriores
			$strSQL="SELECT COUNT(ID) AS TOTAL FROM TB_FOLDER WHERE RULE_WRITE=0 AND ID IN (".$vetor[0][6].")";
			$sql=SQL($strSQL); 
			if(intval($sql[0][0])!='0'){$vetor[0][2]=0;}//else{$vetor[0][2]=1;}
			unset($sql);

			$strSQL="SELECT COUNT(FOLDER_ID) AS TOTAL FROM TB_SHARE_USER WHERE USER_ID=".$user." AND FOLDER_ID IN (".$vetor[0][6].")";
			$sql=SQL($strSQL); 
			if(intval($sql[0][0])!='0'){$vetor[0][2]=0;}//else{$vetor[0][2]=1;}
			unset($sql);

	
			// Verifica se a pasta possui restrições em LEITURA na(s) pasta(s) anteriores
			$strSQL="SELECT COUNT(ID) AS TOTAL FROM TB_FOLDER WHERE RULE_READ=0 AND ID IN (".$vetor[0][6].")";
			$sql=SQL($strSQL); 
			if(intval($sql[0][0])!='0'){$vetor[0][3]=0;}//else{$vetor[0][3]=1;}
			unset($sql);
		}

		return $vetor;
	}



	###########################################################################################################
	# Retorna o nome e caminho da pasta
	# Folder::GetName(12);
	###########################################################################################################
	public static function GetName($id)
	{
		$strSQL="SELECT NAME, PATH, PATH_ID, RULE_WRITE, RULE_READ FROM TB_FOLDER WHERE ID";
		intval($id)==0 ? $strSQL.=" IS NULL" : $strSQL.="=".$id;
		$sql=Sql($strSQL);
		return $sql;
	}

	###########################################################################################################
	# Retorna os subdiretórios de determinado diretório, DE ACORDO com o compartilhamento do usuário
	# Folder::GetFolders(1);
	###########################################################################################################
	public static function GetFolders($id, $group, $user)
	{
		$group=intval($group);
		$user=intval($user);
		
		$strSQL="SELECT A.ID, A.NAME, A.PATH, A.DATA, A.RULE_WRITE, A.RULE_READ, (SELECT RULE_WRITE FROM TB_SHARE_USER WHERE FOLDER_ID=A.ID AND USER_ID=".$user.") AS RULE_WRITE_USER, (SELECT RULE_READ FROM TB_SHARE_USER WHERE FOLDER_ID=A.ID AND USER_ID=".$user.") AS RULE_READ_USER FROM TB_FOLDER A WHERE A.ROOT=";
		intval($id)==0 ? $strSQL.="1" : $strSQL.=$id;
		$strSQL.=" ORDER BY NAME";
		$vetor=Sql($strSQL);
		
		
		
	/*	$vetor[$i][0] = ID da pasta
		$vetor[$i][1] = Nome da pasta
		$vetor[$i][2] = Path fisico
		$vetor[$i][3] = Data de criação
		$vetor[$i][4] = Permite escrita
		$vetor[$i][5] = Permite leitura*/		
		
		for($i=0;$i<count($vetor);$i++)
		{
			if($group==1) //grupo Admin tem acesso total...
			{
				$vetor[$i][4]=1;
				$vetor[$i][5]=1;
				unset($vetor[$i][6],$vetor[$i][7]);
			}
			else
			{
				if(($vetor[$i][4]=='0')||($vetor[$i][6]=='0'))
					$vetor[$i][4]=0;
				else
					$vetor[$i][4]=1;
					
				if(($vetor[$i][5]=='0')||($vetor[$i][7]=='0'))
					$vetor[$i][5]=0;
				else
					$vetor[$i][5]=1;
					
				unset($vetor[$i][6],$vetor[$i][7]);
			}
		}
		
	
		
		
		return $vetor;
	}

	###########################################################################################################
	# Cria um novo diretório
	# Folder::Add(nome, root);
	###########################################################################################################
	public static function Add($name, $pai)
	{
	GLOBAL $cfg;
		$name = Mascara::RenameFolder($name, 30);
		
		//1. Consulta as informações do diretório pai	
		$pai=intval($pai);
		$root=Folder::GetName($pai);
		
		$dir=str_replace("//", "/", ($cfg['path_files'].$root[0][1].'/'.$name.'/'));
		$dir=str_replace("//", "/", $dir);


		//2. Verifica se o diretório existe
		if(!is_dir($dir))
		{
			//3. Cria o diretório
			mkdir($dir, 0777);

			//4. Insere o diretório no Banco de Dados
			$strSQL="INSERT INTO TB_FOLDER (NAME, PATH, ROOT, DATA, RULE_WRITE, RULE_READ) VALUES ('".$name."', '".str_replace($cfg['path_files'], "/", $dir)."', ".$pai.", '".date("Y-m-d H:i")."', 1, 1)";
			ExecutaSql($strSQL);
			
			//5. @@identity
			$strSQL="SELECT ID FROM TB_FOLDER WHERE NAME='".$name."' ORDER BY ID DESC LIMIT 0,1;";
			$sqlFolder=SQL($strSQL);
			
			//6. Consulta o PATH_ID do pai
			$strSQL="SELECT PATH_ID FROM TB_FOLDER WHERE ID=".$pai;
			$sql=SQL($strSQL);
			
			//7. Atualiza o campo PATH_ID
			$strSQL="UPDATE TB_FOLDER SET";
			if(intval($pai)==1)
			{
				$strSQL.=" PATH_ID='0'";
			}
			else
			{
				$strSQL.=" PATH_ID='".$sql[0][0].",".$pai."'";
			}
			$strSQL.=" WHERE ID=".$sqlFolder[0][0];
			ExecutaSql($strSQL);		
		}
	}

	###########################################################################################################
	#	Mover diretório
	#
	#	Folder::Move("C:/web/images/abc/", "C:/web/mp3/");
	#
	###########################################################################################################	
	public static function move($origem, $destino)
	{
		GLOBAL $cfg;
		
		if($origem!=$destino)	//Não se pode mover para a mesma pasta!
		{
			//1. Move o diretório
			$pasta = array_reverse(explode("/", $origem));
			$pasta = $pasta[1];
			rename($cfg['path_files'].substr($origem,1), $cfg['path_files'].substr($destino,1).$pasta).'/';
			
			
			// Consulta as informações da pasta origem
			$strSQL="SELECT ID, NAME, PATH, PATH_ID, ROOT FROM TB_FOLDER WHERE PATH='".$origem."'";
			$infoOrigem=sql($strSQL);
			
			// Consulta as informações da pasta Destino
			$strSQL="SELECT ID, NAME, PATH, PATH_ID, ROOT FROM TB_FOLDER WHERE PATH='".$destino."'";
			$infoDestino=sql($strSQL);
			
			//Atualiza as informações da pasta de origem
			$strSQL="UPDATE TB_FOLDER SET PATH='".$destino.$pasta."/', PATH_ID='".$infoDestino[0][3].", ".$infoDestino[0][0]."', ROOT=".$infoDestino[0][0]." WHERE ID=".$infoOrigem[0][0];
			ExecutaSql($strSQL);
			
			//Consulta as informações das subpastas
			$strSQL="SELECT ID, NAME, PATH, PATH_ID FROM TB_FOLDER WHERE PATH LIKE '".$infoOrigem[0][2]."%' AND ID!=".$infoOrigem[0][0];
			$infoSub=sql($strSQL);
			
			//Atualiza as informações das subpastas de origem
			for($i=0;$i<count($infoSub);$i++)
			{	
				$strSQL="UPDATE TB_FOLDER SET PATH='".$destino.$pasta."/".$infoSub[$i][1]."/', PATH_ID=REPLACE(PATH_ID, '".$infoOrigem[0][3]."','".$infoDestino[0][3].",".$infoDestino[0][0]."') WHERE ID=".$infoSub[$i][0];
				ExecutaSql($strSQL);	
			}
		}
	}



	###########################################################################################################
	#	Renomear diretório
	#
	#	Folder::FolderRename(40, "C:\web\images\abc\", "123");
	#
	###########################################################################################################	
	public static function FolderRename($id, $diretorio, $titulo)
	{
		GLOBAL $cfg;
		$diretorio=str_replace("//", "/", $diretorio);
		$titulo = Mascara::RenameFolder(strtolower($titulo), 40);

		if(is_dir($cfg['path_files'].$diretorio))
		{
			//1. Renomeia o diretório
			rename(substr($cfg['path_files'],0,strrpos($cfg['path_files'],"/")).$diretorio, substr($cfg['path_files'],0,strrpos($cfg['path_files'],"/")).dirname($diretorio).$titulo.'/');
	
			//2. Atualiza o nome no SQL		
			$strSQL="UPDATE TB_FOLDER SET NAME='".$titulo."' WHERE ID=".intval($id);
			ExecutaSql($strSQL);

			//3. Atualiza o PATH no SQL
			//3.1 Retorna os registros com o PATH antigo
			$strSQL="SELECT ID, PATH FROM TB_FOLDER WHERE PATH LIKE '".$diretorio."%';";
			$vetor=Sql($strSQL);
			for($i=0;$i<count($vetor);$i++)
			{
				//3.2 Renomeia os PATHs antigos, para o nome atual
				$strSQL="UPDATE TB_FOLDER SET PATH='".str_replace($diretorio, str_replace("\\", "/", dirname($diretorio).$titulo).'/', $vetor[$i][1])."' WHERE ID=".$vetor[$i][0];
				ExecutaSql($strSQL);
			}
			unset($vetor);	
		}
	}

}?>
