<?php

Class Mascara
{
	var $entrada;
	private $saida;
	
	
	###########################################################################################################
	#	Trata o tamanho do arquivo ()em bytes)
	#	Mascara::ArquivoTamanho($bytes)
	###########################################################################################################	
	public static function ArquivoTamanho($bytes)
	{	
		$a = array("bytes","KB","MB","GB","TB","PB");
		$pos = 0;
		while(intval($bytes)>=1024)
		{	 
			$bytes = $bytes/1024;
			$pos++;
		}
		$saida = round($bytes, 2).' '.$a[$pos];
		return $saida;
	}

	###########################################################################################################
	#	Retorna um novo nome para a pasta informada, de forma a retirar acentos, espaços e caracteres não permitidos
	#	Mascara::RenameFolder(nome, tamanho)
	###########################################################################################################	
	public static function RenameFolder($name, $max)
	{

		//3. Retira acentuação
		$name = str_replace("á", "a", $name);	$name = str_replace("à", "a", $name);	$name = str_replace("ã", "a", $name);	$name = str_replace("â", "a", $name);
		$name = str_replace("é", "e", $name);	$name = str_replace("è", "e", $name);	$name = str_replace("ê", "e", $name);
		$name = str_replace("í", "i", $name);	$name = str_replace("ì", "i", $name);
		$name = str_replace("ó", "o", $name);	$name = str_replace("ô", "o", $name);	$name = str_replace("õ", "o", $name);
		$name = str_replace("ú", "u", $name);	$name = str_replace("ù", "u", $name);	$name = str_replace("ü", "u", $name);

		$name = str_replace("!", "", $name);	$name = str_replace("@", "-", $name);	$name = str_replace("+", "-", $name);
		$name = str_replace(" ", "_", $name);	$name = str_replace("___", "_", $name);	$name = str_replace("__", "_", $name);
		$name = str_replace("ç", "c", $name);	$name = str_replace('"', '', $name);	$name = str_replace("'", '', $name);

		//4. Limita a quantidade de caracteres
		if($max!=0) $name = substr($name,0, $max-1);

		return $name;
	}
	###########################################################################################################
	#	Retorna um novo nome para o arquivo, de forma a retirar acentos, espaços e caracteres não permitidos
	#	Mascara::RenameFile(nome, tamanho)
	###########################################################################################################	
	public static function RenameFile($name, $max)
	{
		//1. Separa a extensão do arquivo
		$extensao = substr($name, strrpos($name, "."));

		//2. Separa apenas o nome do arquivo, sem extensão
		$name = str_replace($extensao, "", $name); 

		//3. Retira acentuação
		$name = str_replace("á", "a", $name);	$name = str_replace("à", "a", $name);	$name = str_replace("ã", "a", $name);	$name = str_replace("â", "a", $name);
		$name = str_replace("é", "e", $name);	$name = str_replace("è", "e", $name);	$name = str_replace("ê", "e", $name);
		$name = str_replace("í", "i", $name);	$name = str_replace("ì", "i", $name);
		$name = str_replace("ó", "o", $name);	$name = str_replace("ô", "o", $name);	$name = str_replace("õ", "o", $name);
		$name = str_replace("ú", "u", $name);	$name = str_replace("ù", "u", $name);	$name = str_replace("ü", "u", $name);

		$name = str_replace("!", "", $name);	$name = str_replace("@", "-", $name);	$name = str_replace("+", "-", $name);
		$name = str_replace(" ", "_", $name);	$name = str_replace("___", "_", $name);	$name = str_replace("__", "_", $name);
		$name = str_replace("ç", "c", $name);	$name = str_replace('"', '', $name);	$name = str_replace("'", '', $name);

		//4. Limita a quantidade de caracteres
		if($max!=0) $name = substr($name,0, $max-1);

		return $name.$extensao;
	}


}
			
		
		


?>
